//
//	Library for utility
//
#include  "MOTTYPES.h"
#include	"hidef.h"
#include	"PortDef.h"
#include	<string.h>

#include	"Struct.h"
#include	"Prototype.h"

//
//	Prototypes
//

//
//	Constants
//
#define	DEBUGPORT	0

//
//	Vars
//
UINT8 (*nvmerase)(UINT8 *ad) @0xe008;	// Jump vector in boot ROM
UINT8 (*nvmwrite)(UINT8 *ad, UINT8 *src, UINT16 size) @0xe00a;
void (*writesrecord)(UINT8 *Buf) @0xe00c;
UINT8 (*flashgetstatus)(void) @0xe00e;
UINT8 (*flashread)(UINT16 bank, UINT8 offset) @0xe010;
void (*flashblockread)(UINT16 bank, UINT8 offset, UINT8 *buffer, UINT16 size) @0xe012;
void (*flashwrite)(UINT16 bank, UINT8 offset, UINT8 *buffer, UINT16 size) @0xe014;
void (*flasherase)(UINT8 bank) @0xe016;
void (*restore)(void) @0xe018;

//
//	Memory Copy
//
#pragma	MESSAGE DISABLE C5703
void BufCopy(UINT8 *dest, UINT8 *src, UINT16 size)
{
	if((UINT8*)dest < (UINT8*)src || (UINT8*)dest > (UINT8*)src + size)
		while(size--)	*((UINT8*)dest)++=*((UINT8*)src)++;
	else
	{
		(UINT8*)dest += size; (UINT8*)src += size;
		while(size--)	*--((UINT8*)dest)=*--((UINT8*)src);
	}
}

//
//	Memory Clear
//
void MemClear(UINT8 *dest, UINT16 size)
{
	asm
	{
		PSHX		// Save size  
		PSHH  
ClearLoop:     
		LDHX  1,SP	// Get size
		CPHX	#0		// 0?
		BEQ		EndClear
		AIX   #-1
		STHX  1,SP
		LDHX  5,SP
		CLR   ,X
		AIX   #1
		STHX  5,SP
		BRA	ClearLoop
EndClear:	
		AIS   #2
	}
}

//
//	Flash erase
//
UINT8 NvmErase(UINT8 *adrs)
{
UINT8	res;
	DisableInterrupts;
	res = (*nvmerase)(adrs);
	EnableInterrupts;
	return res;
}

//
//	Flash write
//
UINT8 NvmWrite(UINT8 *adrs, UINT8 *src, UINT16 size)
{
UINT8	res;
	DisableInterrupts;
	res = (*nvmwrite)(adrs, src, size);
	EnableInterrupts;
	return res;
}
//
//	Write S-format hex data
//
void WriteSrecord(UINT8 *Buf)
{
	(*writesrecord)(Buf);
}

//
//	Get status register
//
UINT8 FlashGetStatus(void)
{
	return (*flashgetstatus)();
}

//
//	Get block data from flash
//
UINT8 FlashRead(UINT16 bank, UINT8 offset)
{
	return (*flashread)(bank, offset);
}

//
//	Get block data from flash
//
void FlashBlockRead(UINT16 bank, UINT8 offset, UINT8 *buffer, UINT16 size)
{
	(*flashblockread)(bank, offset, buffer, size);
}

//
//	Put block data to flash
//
void FlashWrite(UINT16 bank, UINT8 offset, UINT8 *buffer, UINT16 size)
{
	if(bank >= 0x9300 && bank < 0x9400)	// Check magic number?
		bank -= 0x8400;	// Set reserved bank no (15)
	else if(bank >= 0xf00)	// Check normal bank?
		return;	// Invalid bank then do nothing
	(*flashwrite)(bank, offset, buffer, size);
}

